Attribute VB_Name = "Module2"
Option Explicit
'
Public Type GUID
    ' Globally Unique Identifiers (GUID).
    ' This is Microsoft's form of the Universally Unique Identifier (UUID).
    ' See Wikipedia for more.
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(7) As Byte
End Type
'
Private Type KeyboardInput        '   typedef struct tagINPUT {
    dwType As Long                ' Set to INPUT_KEYBOARD.
    wVK As Integer                ' shift, ctrl, menukey, or the key itself.
    wScan As Integer              ' Not being used.
    dwFlags As Long               '            HARDWAREINPUT hi;
    dwTime As Long                ' Not being used.
    dwExtraInfo As Long           ' Not being used.
    dwPadding As Currency         ' Not being used.
End Type
'
Public Declare Function GetMem4 Lib "msvbvm60.dll" (ByRef Source As Any, ByRef Dest As Any) As Long
Public Declare Function ShowWindow Lib "user32.dll" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Public Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)
'
Private Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function GetModuleHandle Lib "kernel32.dll" Alias "GetModuleHandleW" (ByVal lpModuleName As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Private Declare Function LockSetForegroundWindow Lib "user32" (ByVal uLockCode As Long) As Boolean
Private Declare Function AllowSetForegroundWindow Lib "user32" (ByVal dwProcessId As Long) As Boolean
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SendInput Lib "user32" (ByVal nInputs As Long, pInputs As Any, ByVal cbSize As Long) As Long
Private Declare Function VkKeyScan Lib "user32" Alias "VkKeyScanA" (ByVal cChar As Byte) As Integer
'
Dim mhWndOfIdeMain As Long
Dim mhWndOfIdeProjectWindow As Long
'
Private collNamedKeys As Collection
Private collExtendedKeys As Collection
Private Const defBufferSize As Long = 512
Private Const PauseDelay As Long = 50
Private msData As String
Private mlDatPtr As Long
Private muEvents() As KeyboardInput
Private mlEvtPtr As Long
Private mlShiftFlags As Long
'

Public Function InVbgGroup() As Boolean
    ' CAUTION: This may not work correctly if called from a "Form_Activate" event.
    '          It seems to work fine if called from anywhere else.
    Dim h As Long
    '
    h = hWndOfIdeProjectWindow
    If h Then InVbgGroup = Left$(WindowText(h), 16) = "Project Group - "
End Function

Public Function IsCompiled() As Boolean
    ' IDE bInIde bIsIde IsIde InIde IsCompiled Compiled bCompiled.
    '
    ' Allow the following to test "as if" compiled.
    'IsCompiled = True: Exit Function
    '
    '
    On Error GoTo Errored
    Debug.Print 1 / 0
    IsCompiled = True
Errored:
End Function

Public Function RTrimNull(s As String) As String
    Dim i As Integer
    i = InStr(s, vbNullChar)
    If i Then
        RTrimNull = Left$(s, i - 1)
    Else
        RTrimNull = s
    End If
End Function

Public Function hWndOfIdeProjectWindow() As Long
    ' If in the IDE, this returns the handle of the project explorer (modules) IDE window.
    ' If this window isn't open, it gets opened.
    ' CAUTION: This may not work correctly if called from a "Form_Activate" event.
    ' ZERO is returned if the program is not running in the IDE.
    '
    If IsCompiled Then Exit Function
    mhWndOfIdeProjectWindow = 0
    Call EnumWindows(AddressOf EnumForIdeProj, &H0)
    If mhWndOfIdeProjectWindow = 0 Then
        OpenIdeProjectWindow
        Call EnumWindows(AddressOf EnumForIdeProj, &H0)
    End If
    hWndOfIdeProjectWindow = mhWndOfIdeProjectWindow
End Function

Private Function EnumForIdeProj(ByVal hWnd As Long, ByVal lParam As Long) As Long
    EnumForIdeProj = 1
    If App.ThreadId = ThreadId(hWnd) Then
        If WindowClass(hWnd) = "DockingView" Then
            If Left$(WindowText(hWnd), 8) = "Project " Then
                mhWndOfIdeProjectWindow = hWnd
                EnumForIdeProj = 0
            End If
        End If
    End If
End Function

Public Sub OpenIdeProjectWindow()
    ' This fails in the "Form_Activate" event for some reason.
    ' It seems to work anywhere else.
    Dim h As Long
    '
    h = hWndOfIdeMain
    If h = 0 Then Exit Sub
    ForceWindowFocus h
    SendKeysEx "^r", True
End Sub

Public Function hWndOfIdeMain() As Long
    ' If in the IDE, this returns the handle of the main IDE window.
    ' This is the menu/toolbar window that is always open.
    ' ZERO is returned if the program is not running in the IDE.
    mhWndOfIdeMain = 0
    Call EnumWindows(AddressOf EnumForIdeMain, &H0)
    hWndOfIdeMain = mhWndOfIdeMain
End Function

Private Function EnumForIdeMain(ByVal hWnd As Long, ByVal lParam As Long) As Long
    EnumForIdeMain = 1
    If App.ThreadId = ThreadId(hWnd) Then
        If WindowClass(hWnd) = "IDEOwner" Then
            mhWndOfIdeMain = hWnd
            EnumForIdeMain = 0
        End If
    End If
End Function

Public Function WindowText(hWndOfInterest As Long) As String
    ' Form or control.
    Dim s As String
    Dim l As Long
    '
    l = GetWindowTextLength(hWndOfInterest)
    s = Space$(l + 1)
    l = GetWindowText(hWndOfInterest, s, l + 1)
    s = RTrimNull(s)
    WindowText = Trim$(s)
End Function
    
Public Function ThreadId(hWndOfInterest As Long) As Long
    ' This is similar to the process ID, but some application can be multi-threaded.
    ThreadId = GetWindowThreadProcessId(hWndOfInterest, ByVal &H0)
End Function

Public Function WindowClass(hWndOfInterest As Long) As String
    Dim i As Long
    Dim sClassName As String * 256
    i = GetClassName(hWndOfInterest, sClassName, 256)
    WindowClass = Left$(sClassName, i)
End Function

Public Sub ForceWindowFocus(ByVal hWnd As Long)
    Const SW_SHOWNORMAL      As Long = 1
    Const SW_SHOWMINIMIZED   As Long = 2
    Const SW_SHOWMAXIMIZED   As Long = 3
    Const ASFW_ANY As Long = -1
    Const LSFW_UNLOCK As Long = 2
    Const LSFW_LOCK As Long = 1
    ' You should really make sure the window is visible and enabled before this is called.
    LockSetForegroundWindow LSFW_UNLOCK   ' Unlock setforegroundwindow calls
    AllowSetForegroundWindow ASFW_ANY     ' Allow setforeground window calls
    If WindowIsMaximized(hWnd) Then
        ShowWindow hWnd, SW_SHOWMAXIMIZED
    Else
        ShowWindow hWnd, SW_SHOWNORMAL
    End If
    SetForegroundWindow hWnd
    LockSetForegroundWindow LSFW_LOCK     ' Lock other apps from using setforegroundwindow
End Sub

Public Function WindowIsMaximized(hWndOfInterest As Long) As Boolean
    Const GWL_STYLE As Long = -16
    Const WS_MAXIMIZE = &H1000000
    '
    WindowIsMaximized = ((GetWindowLong(hWndOfInterest, GWL_STYLE) And WS_MAXIMIZE) = WS_MAXIMIZE)
End Function

Public Sub SendKeysEx(Data As String, Optional DoPauses As Boolean = False)
    ' Sendkeys but better.
    Dim i As Long
    Const INPUT_KEYBOARD As Long = 1
    '
    ' Make sure our collection of named keys has been built.
    If collNamedKeys Is Nothing Then BuildCollections
    '
    ' Clear buffer, reset pointers, and cache send data.
    ReDim muEvents(0 To defBufferSize - 1) As KeyboardInput
    mlEvtPtr = 0
    mlDatPtr = 0
    msData = Data
    '
    ' Loop through entire passed string.
    Do While mlDatPtr < Len(Data)
        ' Process next token in data string.
        DoNextChr
        ' Make sure there's still plenty of room in the buffer.
        If mlEvtPtr >= (UBound(muEvents) - 24) Then ReDim Preserve muEvents(0 To (UBound(muEvents) + defBufferSize) - 1)
    Loop
    '
    ' Send the processed string to the foreground window!
    If mlEvtPtr > 0 Then
        ' All events are keyboard based.
        For i = 0 To mlEvtPtr - 1
            muEvents(i).dwType = INPUT_KEYBOARD
        Next i
        SendInput mlEvtPtr, muEvents(0), Len(muEvents(0))
        If DoPauses Then Sleep PauseDelay
    End If
    '
    ' Clean up
    Erase muEvents
End Sub

Private Sub AddKeyString(ByVal KeyCode As Long, KeyName As String, Optional ByVal Extended As Boolean)
    ' Add to collection(s) of named keycode constants.
    collNamedKeys.Add KeyCode, KeyName
    If Extended Then collExtendedKeys.Add KeyCode, KeyName
End Sub

Private Sub BuildCollections()
    ' Reset both collections of known named keys.
    Set collNamedKeys = New Collection
    Set collExtendedKeys = New Collection
    ' The extended-key flag indicates whether the keystroke message
    ' originated from one of the additional keys on the enhanced
    ' keyboard. The extended keys consist of the ALT and CTRL keys
    ' on the right-hand side of the keyboard; the INS, DEL, HOME, END,
    ' PAGE UP, PAGE DOWN, and arrow keys in the clusters to the left
    ' of the numeric keypad; the NUM LOCK key; the BREAK (CTRL+PAUSE)
    ' key; the PRINT SCRN key; and the divide (/) and ENTER keys in
    ' the numeric keypad. The extended-key flag is set if the key is
    ' an extended key.
    AddKeyString vbKeyBack, "BACKSPACE"
    AddKeyString vbKeyBack, "BS"
    AddKeyString vbKeyBack, "BKSP"
    AddKeyString vbKeyPause, "BREAK", True
    AddKeyString vbKeyCapital, "CAPSLOCK"
    AddKeyString vbKeyDelete, "DELETE", True
    AddKeyString vbKeyDelete, "DEL", True
    AddKeyString vbKeyDown, "DOWN", True
    AddKeyString vbKeyEnd, "END", True
    AddKeyString vbKeyReturn, "ENTER"
    AddKeyString vbKeyReturn, "~"
    AddKeyString vbKeyEscape, "ESC"
    AddKeyString vbKeyHelp, "HELP"
    AddKeyString vbKeyHome, "HOME", True
    AddKeyString vbKeyInsert, "INS", True
    AddKeyString vbKeyInsert, "INSERT", True
    AddKeyString vbKeyLeft, "LEFT", True
    AddKeyString vbKeyNumlock, "NUMLOCK", True
    AddKeyString vbKeyPageDown, "PGDN", True
    AddKeyString vbKeyPageUp, "PGUP", True
    AddKeyString vbKeyPause, "PAUSE"
    AddKeyString vbKeyPrint, "PRINT", True
    AddKeyString vbKeySnapshot, "PRTSC", True
    AddKeyString vbKeySnapshot, "PRTSCN", True
    AddKeyString vbKeySnapshot, "PRINTSCRN", True
    AddKeyString vbKeySnapshot, "PRINTSCREEN", True
    AddKeyString vbKeyRight, "RIGHT", True
    AddKeyString vbKeyScrollLock, "SCROLLLOCK"
    AddKeyString vbKeySelect, "SELECT"
    AddKeyString vbKeyTab, "TAB"
    AddKeyString vbKeyUp, "UP", True
    AddKeyString vbKeyF1, "F1"
    AddKeyString vbKeyF2, "F2"
    AddKeyString vbKeyF3, "F3"
    AddKeyString vbKeyF4, "F4"
    AddKeyString vbKeyF5, "F5"
    AddKeyString vbKeyF6, "F6"
    AddKeyString vbKeyF7, "F7"
    AddKeyString vbKeyF8, "F8"
    AddKeyString vbKeyF9, "F9"
    AddKeyString vbKeyF10, "F10"
    AddKeyString vbKeyF11, "F11"
    AddKeyString vbKeyF12, "F12"
    AddKeyString vbKeyF13, "F13"
    AddKeyString vbKeyF14, "F14"
    AddKeyString vbKeyF15, "F15"
    AddKeyString vbKeyF16, "F16"
End Sub

Private Sub DoNextChr()
    Dim This As String
    '
    ' Advance data pointer, and extract next char.
    mlDatPtr = mlDatPtr + 1
    This = Mid$(msData, mlDatPtr, 1)
    '
    ' Branch to appropriate helper routine.
    Select Case True
    Case InStr("+^%", This) <> 0
        ProcessShiftCtrlAlt This
    Case This = "("
        ProcessGroup
    Case This = "{"
        ProcessNamedKey
    Case Else
        ProcessChar This
    End Select
End Sub

Private Sub ProcessShiftCtrlAlt(shiftkey As String)
    Const KEYEVENTF_KEYUP As Long = 2
    ' Press appropriate shiftkey.
    Select Case shiftkey
    Case "+"
        muEvents(mlEvtPtr).wVK = vbKeyShift
        mlShiftFlags = mlShiftFlags Or vbShiftMask
    Case "^"
        muEvents(mlEvtPtr).wVK = vbKeyControl
        mlShiftFlags = mlShiftFlags Or vbCtrlMask
    Case "%"
        muEvents(mlEvtPtr).wVK = vbKeyMenu
        mlShiftFlags = mlShiftFlags Or vbAltMask
    End Select
    mlEvtPtr = mlEvtPtr + 1
    '
    ' Process next set of data.
    DoNextChr
    '
    ' Unpress same shiftkey.
    Select Case shiftkey
    Case "+"
        muEvents(mlEvtPtr).wVK = vbKeyShift
        mlShiftFlags = mlShiftFlags And Not vbShiftMask
    Case "^"
        muEvents(mlEvtPtr).wVK = vbKeyControl
        mlShiftFlags = mlShiftFlags And Not vbCtrlMask
    Case "%"
        muEvents(mlEvtPtr).wVK = vbKeyMenu
        mlShiftFlags = mlShiftFlags And Not vbAltMask
    End Select
    muEvents(mlEvtPtr).dwFlags = KEYEVENTF_KEYUP
    mlEvtPtr = mlEvtPtr + 1
End Sub

Private Sub ProcessGroup()
    Dim EndPtr As Long
    Dim This As String
    Dim i As Long
    '
    ' Groups of characters are offered together, surrounded by parenthesis,
    ' in order to all be modified by shift key(s).  We need to dig out the
    ' remainder of the group, and process each in turn.
    EndPtr = InStr(mlDatPtr, msData, ")")
    ' No need to do anything if endgroup immediateyl follows beginning.
    If EndPtr > (mlDatPtr + 1) Then
        For i = 1 To (EndPtr - mlDatPtr - 1)
            This = Mid$(msData, mlDatPtr + i, 1)
            Call ProcessChar(This)
        Next i
        ' Advance data pointer to closing parenthesis.
        mlDatPtr = EndPtr
    End If
End Sub

Private Sub ProcessNamedKey()
    Dim EndPtr As Long
    Dim This As String
    Dim pieces As Variant  '() As String
    Dim repeat As Long
    Dim vk As Integer
    Dim capped As Boolean
    Dim extend As Boolean
    Dim i As Long
    '
    ' Groups of characters are offered together, surrounded by braces,
    ' representing a named keystroke.  We need to dig out the actual
    ' name, and optionally the number of times this keystroke is repeated.
    EndPtr = InStr(mlDatPtr, msData, "}")
    ' No need to do anything if endgroup immediately follows beginning.
    If EndPtr > (mlDatPtr + 1) Then
        ' Extract group of characters.
        This = Mid$(msData, mlDatPtr + 1, EndPtr - mlDatPtr - 1)
         '
        ' Break into pieces, if possible.
        pieces = Split(This, " ")
        '
        ' Second element, if avail, is number of times to repeat stroke.
        If UBound(pieces) > 0 Then repeat = Val(pieces(1))
        If repeat < 1 Then repeat = 1
        '
        ' Attempt to retrieve named keycode, or else retrieve standard code.
        vk = GetNamedKey(CStr(pieces(0)))
        If vk Then
            ' Is this an extended key?
            extend = IsExtendedKey(This)
        Else
            ' Not a standard named key.
            vk = VkKeyScan(Asc(This))
            capped = CBool(ByteHi(vk) And 1)
            vk = ByteLo(vk)
        End If
        '
        ' Stuff buffer as many times as required.
        For i = 1 To repeat
            Call StuffBuffer(vk, capped, extend)
        Next i
        '
        ' Advance data pointer to closing parenthesis.
        mlDatPtr = EndPtr
    End If
End Sub

Private Sub ProcessChar(This As String)
    Dim vk As Integer
    Dim capped As Boolean
    '
    ' Add input events for single character, taking capitalization
    ' into account.  HiByte will contain the shift state, and LoByte
    ' will contain the key code.
    vk = VkKeyScan(Asc(This))
    capped = CBool(ByteHi(vk) And 1)
    vk = ByteLo(vk)
    StuffBuffer vk, capped
End Sub

Private Function GetNamedKey(This As String) As Integer
    ' Try retrieving from collection
    On Error Resume Next
        GetNamedKey = collNamedKeys(UCase$(This))
    On Error GoTo 0
End Function

Private Function IsExtendedKey(This As String) As Boolean
    Dim nRet As Integer
    ' Try retrieving from collection.
    On Error Resume Next
        nRet = collExtendedKeys(UCase$(This))
        IsExtendedKey = (nRet <> 0)
    On Error GoTo 0
End Function

Private Function ByteHi(ByVal WordIn As Integer) As Byte
    ' Lop off low byte with divide. If less than
    ' zero, then account for sign bit (adding &h10000
    ' implicitly converts to Long before divide).
    If WordIn < 0 Then
        ByteHi = (WordIn + &H10000) \ &H100
    Else
        ByteHi = WordIn \ &H100
    End If
End Function

Private Function ByteLo(ByVal WordIn As Integer) As Byte
    ' Mask off high byte and return low.
    ByteLo = WordIn And &HFF
End Function

Private Sub StuffBuffer(ByVal vk As Integer, Optional Shifted As Boolean, Optional Extended As Boolean)
    Const KEYEVENTF_EXTENDEDKEY As Long = 1
    Const KEYEVENTF_KEYUP As Long = 2
    ' Only mess with Shift key if not already pressed.
    If CBool(mlShiftFlags And vbShiftMask) = False Then
        If Shifted Then
            muEvents(mlEvtPtr).wVK = vbKeyShift
            mlEvtPtr = mlEvtPtr + 1
        End If
    End If
    '
    ' Press and release this key.
    muEvents(mlEvtPtr).wVK = vk
    If Extended Then muEvents(mlEvtPtr).dwFlags = KEYEVENTF_EXTENDEDKEY
    mlEvtPtr = mlEvtPtr + 1
    muEvents(mlEvtPtr).wVK = vk
    muEvents(mlEvtPtr).dwFlags = muEvents(mlEvtPtr).dwFlags Or KEYEVENTF_KEYUP
    mlEvtPtr = mlEvtPtr + 1
    '
    ' Only mess with Shift key if not already pressed.
    If CBool(mlShiftFlags And vbShiftMask) = False Then
        If Shifted Then
            muEvents(mlEvtPtr).wVK = vbKeyShift
            muEvents(mlEvtPtr).dwFlags = KEYEVENTF_KEYUP
            mlEvtPtr = mlEvtPtr + 1
        End If
    End If
End Sub

